#pragma once

#include "ehs/Types.h"

namespace ehs
{
	class DbVar
	{
	private:
		UInt_64 hashId;
		UInt_64 size;
		Byte* data;

	public:
		~DbVar();

		DbVar();

		DbVar(UInt_64 hashId, UInt_64 size, Byte* data);

		DbVar(DbVar&& var) noexcept;

		DbVar(const DbVar& var);

		DbVar& operator=(DbVar&& var) noexcept;

		DbVar& operator=(const DbVar& var);

		explicit operator Byte*() const;

		UInt_64 GetHashId() const;

		UInt_64 GetSize() const;

		Byte* GetData() const;
	};
}