#pragma once

#include "DbType.h"
#include "ehs/EHS.h"
#include "ehs/BaseObj.h"
#include "ehs/Str.h"

namespace ehs
{
	class DbVarTmpl : public BaseObj
	{
	private:
		UInt_64 hashId;
		Str_8 id;
		DbType type;
		bool array;

	public:
		DbVarTmpl();

		DbVarTmpl(Str_8 id, DbType type, bool array);

		DbVarTmpl(DbVarTmpl&& varTmpl) noexcept;

		DbVarTmpl(const DbVarTmpl& varTmpl);

		DbVarTmpl& operator=(DbVarTmpl&& varTmpl) noexcept;

		DbVarTmpl& operator=(const DbVarTmpl& varTmpl);

		UInt_64 GetHashId() const;

		void SetId(Str_8 newId);

		Str_8 GetId() const;

		void SetType(DbType newType);

		DbType GetType() const;

		void SetIsArray(bool value);

		bool IsArray() const;
	};
}
