#include "ehs/db/DbVarTmpl.h"

namespace ehs
{
	DbVarTmpl::DbVarTmpl()
		: hashId(0), type(DbType::SINT_64), array(false)
	{
	}

	DbVarTmpl::DbVarTmpl(Str_8 id, DbType type, bool array)
		: hashId(id.Hash_64()), id((Str_8&&)id), type(type), array(array)
	{
	}

	DbVarTmpl::DbVarTmpl(DbVarTmpl&& varTmpl) noexcept
		: hashId(varTmpl.hashId), id((Str_8&&)varTmpl.id), type(varTmpl.type), array(varTmpl.array)
	{
		varTmpl.hashId = 0;
		varTmpl.type = DbType::SINT_64;
		varTmpl.array = false;
	}

	DbVarTmpl::DbVarTmpl(const DbVarTmpl& varTmpl)
		: hashId(varTmpl.hashId), id(varTmpl.id), type(varTmpl.type), array(varTmpl.array)
	{
	}

	DbVarTmpl& DbVarTmpl::operator=(DbVarTmpl&& varTmpl) noexcept
	{
		if (this == &varTmpl)
			return *this;

		hashId = varTmpl.hashId;
		id = (Str_8&&)varTmpl.id;
		type = varTmpl.type;
		array = varTmpl.array;

		varTmpl.hashId = 0;
		varTmpl.type = DbType::SINT_64;
		varTmpl.array = false;

		return *this;
	}

	DbVarTmpl& DbVarTmpl::operator=(const DbVarTmpl& varTmpl)
	{
		if (this == &varTmpl)
			return *this;

		hashId = varTmpl.hashId;
		id = varTmpl.id;
		type = varTmpl.type;
		array = varTmpl.array;

		return *this;
	}

	UInt_64 DbVarTmpl::GetHashId() const
	{
		return hashId;
	}

	void DbVarTmpl::SetId(Str_8 newId)
	{
		hashId = newId.Hash_64();
		id = (Str_8&&)newId;
	}

	Str_8 DbVarTmpl::GetId() const
	{
		return id;
	}

	void DbVarTmpl::SetType(DbType newType)
	{
		type = newType;
	}

	DbType DbVarTmpl::GetType() const
	{
		return type;
	}

	void DbVarTmpl::SetIsArray(bool value)
	{
		array = value;
	}

	bool DbVarTmpl::IsArray() const
	{
		return array;
	}
}
